Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.beans.factory
Class BeanFactoryUtils

    java.lang.Object
      org.springframework.beans.factory.BeanFactoryUtils

    public abstract class BeanFactoryUtils

extends java.lang.Object

Convenience methods operating on bean factories, in particular on the `ListableBeanFactory` interface.

Returns bean counts, bean names or bean instances, taking into account the nesting hierarchy of a bean factory (which the methods defined on the ListableBeanFactory interface don't, in contrast to the methods defined on the BeanFactory interface).

Since:
  04.07.2003
Author:
  Rod Johnson, Juergen Hoeller, Chris Beams

Field Summary
`static java.lang.String` | `GENERATED_BEAN_NAME_SEPARATOR` Separator for generated bean names.

Constructor Summary
`BeanFactoryUtils()`

Method Summary
`static java.lang.String[]` | `beanNamesForTypeIncludingAncestors(ListableBeanFactory lbf, java.lang.Class type)` Get all bean names for the given type, including those defined in ancestor factories.
`static java.lang.String[]` | `beanNamesForTypeIncludingAncestors(ListableBeanFactory lbf, java.lang.Class type, boolean includeNonSingletons, boolean allowEagerInit)` Get all bean names for the given type, including those defined in ancestor factories.
`static java.lang.String[]` | `beanNamesIncludingAncestors(ListableBeanFactory lbf)` Return all bean names in the factory, including ancestor factories.
`static
`<T> T`
` | `beanOfType(ListableBeanFactory lbf, java.lang.Class<T> type)` Return a single bean of the given type or subtypes, not looking in ancestor factories.
`static
`<T> T`
` | `beanOfType(ListableBeanFactory lbf, java.lang.Class<T> type, boolean includeNonSingletons, boolean allowEagerInit)` Return a single bean of the given type or subtypes, not looking in ancestor factories.
`static
`<T> T`
` | `beanOfTypeIncludingAncestors(ListableBeanFactory lbf, java.lang.Class<T> type)` Return a single bean of the given type or subtypes, also picking up beans defined in ancestor bean factories if the current bean factory is a HierarchicalBeanFactory.
`static
`<T> T`
` | `beanOfTypeIncludingAncestors(ListableBeanFactory lbf, java.lang.Class<T> type, boolean includeNonSingletons, boolean allowEagerInit)` Return a single bean of the given type or subtypes, also picking up beans defined in ancestor bean factories if the current bean factory is a HierarchicalBeanFactory.
`static
`<T> java.util.Map<java.lang.String,T>`
` | `beansOfTypeIncludingAncestors(ListableBeanFactory lbf, java.lang.Class<T> type)` Return all beans of the given type or subtypes, also picking up beans defined in ancestor bean factories if the current bean factory is a HierarchicalBeanFactory.
`static
`<T> java.util.Map<java.lang.String,T>`
` | `beansOfTypeIncludingAncestors(ListableBeanFactory lbf, java.lang.Class<T> type, boolean includeNonSingletons, boolean allowEagerInit)` Return all beans of the given type or subtypes, also picking up beans defined in ancestor bean factories if the current bean factory is a HierarchicalBeanFactory.
`static int` | `countBeansIncludingAncestors(ListableBeanFactory lbf)` Count all beans in any hierarchy in which this factory participates.
`static boolean` | `isFactoryDereference(java.lang.String name)` Return whether the given name is a factory dereference (beginning with the factory dereference prefix).
`static boolean` | `isGeneratedBeanName(java.lang.String name)` Return whether the given name is a bean name which has been generated by the default naming strategy (containing a "#..." part).
`static java.lang.String` | `originalBeanName(java.lang.String name)` Extract the "raw" bean name from the given (potentially generated) bean name, excluding any "#..." suffixes which might have been added for uniqueness.
`static java.lang.String` | `transformedBeanName(java.lang.String name)` Return the actual bean name, stripping out the factory dereference prefix (if any, also stripping repeated factory prefixes if found).

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### GENERATED_BEAN_NAME_SEPARATOR

    public static final java.lang.String GENERATED_BEAN_NAME_SEPARATOR

  Separator for generated bean names. If a class name or parent name is not unique, "#1", "#2" etc will be appended, until the name becomes unique.

  See Also:
    Constant Field Values

Constructor Detail

### BeanFactoryUtils

    public BeanFactoryUtils()

Method Detail

### isFactoryDereference

    public static boolean isFactoryDereference(java.lang.String name)

  Return whether the given name is a factory dereference (beginning with the factory dereference prefix).

  Parameters:
    `name` - the name of the bean
  Returns:
    whether the given name is a factory dereference
  See Also:
    `BeanFactory.FACTORY_BEAN_PREFIX`

### transformedBeanName

    public static java.lang.String transformedBeanName(java.lang.String name)

  Return the actual bean name, stripping out the factory dereference prefix (if any, also stripping repeated factory prefixes if found).

  Parameters:
    `name` - the name of the bean
  Returns:
    the transformed name
  See Also:
    `BeanFactory.FACTORY_BEAN_PREFIX`

### isGeneratedBeanName

    public static boolean isGeneratedBeanName(java.lang.String name)

  Return whether the given name is a bean name which has been generated by the default naming strategy (containing a "#..." part).

  Parameters:
    `name` - the name of the bean
  Returns:
    whether the given name is a generated bean name
  See Also:
    `GENERATED_BEAN_NAME_SEPARATOR`, `BeanDefinitionReaderUtils.generateBeanName(org.springframework.beans.factory.config.BeanDefinition, org.springframework.beans.factory.support.BeanDefinitionRegistry, boolean)`, `DefaultBeanNameGenerator`

### originalBeanName

    public static java.lang.String originalBeanName(java.lang.String name)

  Extract the "raw" bean name from the given (potentially generated) bean name, excluding any "#..." suffixes which might have been added for uniqueness.

  Parameters:
    `name` - the potentially generated bean name
  Returns:
    the raw bean name
  See Also:
    `GENERATED_BEAN_NAME_SEPARATOR`

### countBeansIncludingAncestors

    public static int countBeansIncludingAncestors(ListableBeanFactory lbf)

  Count all beans in any hierarchy in which this factory participates. Includes counts of ancestor bean factories.

  Beans that are "overridden" (specified in a descendant factory with the same name) are only counted once.

  Parameters:
    `lbf` - the bean factory
  Returns:
    count of beans including those defined in ancestor factories

### beanNamesIncludingAncestors

    public static java.lang.String[] beanNamesIncludingAncestors(ListableBeanFactory lbf)

  Return all bean names in the factory, including ancestor factories.

  Parameters:
    `lbf` - the bean factory
  Returns:
    the array of matching bean names, or an empty array if none
  See Also:
    `beanNamesForTypeIncludingAncestors(org.springframework.beans.factory.ListableBeanFactory, java.lang.Class)`

### beanNamesForTypeIncludingAncestors

    public static java.lang.String[] beanNamesForTypeIncludingAncestors(ListableBeanFactory lbf,
                                                                        java.lang.Class type)

  Get all bean names for the given type, including those defined in ancestor factories. Will return unique names in case of overridden bean definitions.

  Does consider objects created by FactoryBeans, which means that FactoryBeans will get initialized. If the object created by the FactoryBean doesn't match, the raw FactoryBean itself will be matched against the type.

  This version of `beanNamesForTypeIncludingAncestors` automatically includes prototypes and FactoryBeans.

  Parameters:
    `lbf` - the bean factory
    `type` - the type that beans must match
  Returns:
    the array of matching bean names, or an empty array if none

### beanNamesForTypeIncludingAncestors

    public static java.lang.String[] beanNamesForTypeIncludingAncestors(ListableBeanFactory lbf,
                                                                        java.lang.Class type,
                                                                        boolean includeNonSingletons,
                                                                        boolean allowEagerInit)

  Get all bean names for the given type, including those defined in ancestor factories. Will return unique names in case of overridden bean definitions.

  Does consider objects created by FactoryBeans if the "allowEagerInit" flag is set, which means that FactoryBeans will get initialized. If the object created by the FactoryBean doesn't match, the raw FactoryBean itself will be matched against the type. If "allowEagerInit" is not set, only raw FactoryBeans will be checked (which doesn't require initialization of each FactoryBean).

  Parameters:
    `lbf` - the bean factory
    `includeNonSingletons` - whether to include prototype or scoped beans too or just singletons (also applies to FactoryBeans)
    `allowEagerInit` - whether to initialize lazy-init singletons and objects created by FactoryBeans (or by factory methods with a "factory-bean" reference) for the type check. Note that FactoryBeans need to be eagerly initialized to determine their type: So be aware that passing in "true" for this flag will initialize FactoryBeans and "factory-bean" references.
    `type` - the type that beans must match
  Returns:
    the array of matching bean names, or an empty array if none

### beansOfTypeIncludingAncestors

    public static <T> java.util.Map<java.lang.String,T> beansOfTypeIncludingAncestors(ListableBeanFactory lbf,
                                                                                      java.lang.Class<T> type)
                                                                           throws BeansException

  Return all beans of the given type or subtypes, also picking up beans defined in ancestor bean factories if the current bean factory is a HierarchicalBeanFactory. The returned Map will only contain beans of this type.

  Does consider objects created by FactoryBeans, which means that FactoryBeans will get initialized. If the object created by the FactoryBean doesn't match, the raw FactoryBean itself will be matched against the type.

  Note: Beans of the same name will take precedence at the 'lowest' factory level, i.e. such beans will be returned from the lowest factory that they are being found in, hiding corresponding beans in ancestor factories. This feature allows for 'replacing' beans by explicitly choosing the same bean name in a child factory; the bean in the ancestor factory won't be visible then, not even for by-type lookups.

  Parameters:
    `lbf` - the bean factory
    `type` - type of bean to match
  Returns:
    the Map of matching bean instances, or an empty Map if none
  Throws:
    `BeansException` - if a bean could not be created

### beansOfTypeIncludingAncestors

    public static <T> java.util.Map<java.lang.String,T> beansOfTypeIncludingAncestors(ListableBeanFactory lbf,
                                                                                      java.lang.Class<T> type,
                                                                                      boolean includeNonSingletons,
                                                                                      boolean allowEagerInit)
                                                                           throws BeansException

  Return all beans of the given type or subtypes, also picking up beans defined in ancestor bean factories if the current bean factory is a HierarchicalBeanFactory. The returned Map will only contain beans of this type.

  Does consider objects created by FactoryBeans if the "allowEagerInit" flag is set, which means that FactoryBeans will get initialized. If the object created by the FactoryBean doesn't match, the raw FactoryBean itself will be matched against the type. If "allowEagerInit" is not set, only raw FactoryBeans will be checked (which doesn't require initialization of each FactoryBean).

  Note: Beans of the same name will take precedence at the 'lowest' factory level, i.e. such beans will be returned from the lowest factory that they are being found in, hiding corresponding beans in ancestor factories. This feature allows for 'replacing' beans by explicitly choosing the same bean name in a child factory; the bean in the ancestor factory won't be visible then, not even for by-type lookups.

  Parameters:
    `lbf` - the bean factory
    `type` - type of bean to match
    `includeNonSingletons` - whether to include prototype or scoped beans too or just singletons (also applies to FactoryBeans)
    `allowEagerInit` - whether to initialize lazy-init singletons and objects created by FactoryBeans (or by factory methods with a "factory-bean" reference) for the type check. Note that FactoryBeans need to be eagerly initialized to determine their type: So be aware that passing in "true" for this flag will initialize FactoryBeans and "factory-bean" references.
  Returns:
    the Map of matching bean instances, or an empty Map if none
  Throws:
    `BeansException` - if a bean could not be created

### beanOfTypeIncludingAncestors

    public static <T> T beanOfTypeIncludingAncestors(ListableBeanFactory lbf,
                                                     java.lang.Class<T> type)
                                          throws BeansException

  Return a single bean of the given type or subtypes, also picking up beans defined in ancestor bean factories if the current bean factory is a HierarchicalBeanFactory. Useful convenience method when we expect a single bean and don't care about the bean name.

  Does consider objects created by FactoryBeans, which means that FactoryBeans will get initialized. If the object created by the FactoryBean doesn't match, the raw FactoryBean itself will be matched against the type.

  This version of `beanOfTypeIncludingAncestors` automatically includes prototypes and FactoryBeans.

  Note: Beans of the same name will take precedence at the 'lowest' factory level, i.e. such beans will be returned from the lowest factory that they are being found in, hiding corresponding beans in ancestor factories. This feature allows for 'replacing' beans by explicitly choosing the same bean name in a child factory; the bean in the ancestor factory won't be visible then, not even for by-type lookups.

  Parameters:
    `lbf` - the bean factory
    `type` - type of bean to match
  Returns:
    the matching bean instance
  Throws:
    `NoSuchBeanDefinitionException` - if 0 or more than 1 beans of the given type were found
    `BeansException` - if the bean could not be created

### beanOfTypeIncludingAncestors

    public static <T> T beanOfTypeIncludingAncestors(ListableBeanFactory lbf,
                                                     java.lang.Class<T> type,
                                                     boolean includeNonSingletons,
                                                     boolean allowEagerInit)
                                          throws BeansException

  Return a single bean of the given type or subtypes, also picking up beans defined in ancestor bean factories if the current bean factory is a HierarchicalBeanFactory. Useful convenience method when we expect a single bean and don't care about the bean name.

  Does consider objects created by FactoryBeans if the "allowEagerInit" flag is set, which means that FactoryBeans will get initialized. If the object created by the FactoryBean doesn't match, the raw FactoryBean itself will be matched against the type. If "allowEagerInit" is not set, only raw FactoryBeans will be checked (which doesn't require initialization of each FactoryBean).

  Note: Beans of the same name will take precedence at the 'lowest' factory level, i.e. such beans will be returned from the lowest factory that they are being found in, hiding corresponding beans in ancestor factories. This feature allows for 'replacing' beans by explicitly choosing the same bean name in a child factory; the bean in the ancestor factory won't be visible then, not even for by-type lookups.

  Parameters:
    `lbf` - the bean factory
    `type` - type of bean to match
    `includeNonSingletons` - whether to include prototype or scoped beans too or just singletons (also applies to FactoryBeans)
    `allowEagerInit` - whether to initialize lazy-init singletons and objects created by FactoryBeans (or by factory methods with a "factory-bean" reference) for the type check. Note that FactoryBeans need to be eagerly initialized to determine their type: So be aware that passing in "true" for this flag will initialize FactoryBeans and "factory-bean" references.
  Returns:
    the matching bean instance
  Throws:
    `NoSuchBeanDefinitionException` - if 0 or more than 1 beans of the given type were found
    `BeansException` - if the bean could not be created

### beanOfType

    public static <T> T beanOfType(ListableBeanFactory lbf,
                                   java.lang.Class<T> type)
                        throws BeansException

  Return a single bean of the given type or subtypes, not looking in ancestor factories. Useful convenience method when we expect a single bean and don't care about the bean name.

  Does consider objects created by FactoryBeans, which means that FactoryBeans will get initialized. If the object created by the FactoryBean doesn't match, the raw FactoryBean itself will be matched against the type.

  This version of `beanOfType` automatically includes prototypes and FactoryBeans.

  Parameters:
    `lbf` - the bean factory
    `type` - type of bean to match
  Returns:
    the matching bean instance
  Throws:
    `NoSuchBeanDefinitionException` - if 0 or more than 1 beans of the given type were found
    `BeansException` - if the bean could not be created

### beanOfType

    public static <T> T beanOfType(ListableBeanFactory lbf,
                                   java.lang.Class<T> type,
                                   boolean includeNonSingletons,
                                   boolean allowEagerInit)
                        throws BeansException

  Return a single bean of the given type or subtypes, not looking in ancestor factories. Useful convenience method when we expect a single bean and don't care about the bean name.

  Does consider objects created by FactoryBeans if the "allowEagerInit" flag is set, which means that FactoryBeans will get initialized. If the object created by the FactoryBean doesn't match, the raw FactoryBean itself will be matched against the type. If "allowEagerInit" is not set, only raw FactoryBeans will be checked (which doesn't require initialization of each FactoryBean).

  Parameters:
    `lbf` - the bean factory
    `type` - type of bean to match
    `includeNonSingletons` - whether to include prototype or scoped beans too or just singletons (also applies to FactoryBeans)
    `allowEagerInit` - whether to initialize lazy-init singletons and objects created by FactoryBeans (or by factory methods with a "factory-bean" reference) for the type check. Note that FactoryBeans need to be eagerly initialized to determine their type: So be aware that passing in "true" for this flag will initialize FactoryBeans and "factory-bean" references.
  Returns:
    the matching bean instance
  Throws:
    `NoSuchBeanDefinitionException` - if 0 or more than 1 beans of the given type were found
    `BeansException` - if the bean could not be created

Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD